"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const Metadata_1 = require("../Metadata/Metadata");
/**
 * Defines redis hash property
 *
 * @export
 * @param [name] Property name to store in redis
 * @returns
 */
function Property(nameOrType, type) {
    return function (target, propertyKey) {
        const designType = Reflect.getMetadata("design:type", target, propertyKey);
        const name = typeof nameOrType === "string" ? nameOrType : propertyKey;
        const propertyType = typeof nameOrType === "function"
            ? nameOrType
            : type
                ? type
                : designType;
        const properties = Reflect.getMetadata(Metadata_1.REDIS_PROPERTIES, target.constructor) || [];
        properties.push({
            propertyName: propertyKey,
            propertyRedisName: name,
            isIdentifyColumn: false,
            propertyType: propertyType,
            isRelation: false,
        });
        Reflect.defineMetadata(Metadata_1.REDIS_PROPERTIES, properties, target.constructor);
    };
}
exports.Property = Property;
//# sourceMappingURL=Property.js.map