import { RelationOptions } from "../Metadata/Metadata";
export declare type RelationTypeFunc = (type?: any) => Function | Function[];
/**
 * Defines single or multiple relation property
 *
 * @export
 * @param type Type function which must return type of relation / property type
 * @param propertyType Property type. For single relation must be
 */
export declare function RelationProperty(type: RelationTypeFunc): PropertyDecorator;
/**
 * Defines single or multiple relation property
 *
 * @export
 * @param type Type function which must return type of relation / property type
 * @param [options] Options
 */
export declare function RelationProperty(type: RelationTypeFunc, options?: RelationOptions): PropertyDecorator;
