"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class AlreadyConnectedError extends Error {
    constructor() {
        super("Already connected to Redis");
    }
}
exports.AlreadyConnectedError = AlreadyConnectedError;
class MetadataError extends Error {
    constructor(entity, msg) {
        super(`Metadata error for ${entity.name}: ${msg}`);
    }
}
exports.MetadataError = MetadataError;
class DuplicateIdsInEntityError extends Error {
    constructor(entity, id) {
        super(`Entity of type ${entity.constructor.name} with same IDs: ${id} but with different object links were found`);
    }
}
exports.DuplicateIdsInEntityError = DuplicateIdsInEntityError;
//# sourceMappingURL=Errors.js.map