"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
function __export(m) {
    for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
}
Object.defineProperty(exports, "__esModule", { value: true });
const LazyMap_1 = require("./Collections/LazyMap");
exports.LazyMap = LazyMap_1.LazyMap;
const LazySet_1 = require("./Collections/LazySet");
exports.LazySet = LazySet_1.LazySet;
const RedisLazyMap_1 = require("./Collections/RedisLazyMap");
exports.RedisLazyMap = RedisLazyMap_1.RedisLazyMap;
const RedisLazySet_1 = require("./Collections/RedisLazySet");
exports.RedisLazySet = RedisLazySet_1.RedisLazySet;
const Connection_1 = require("./Connection/Connection");
exports.Connection = Connection_1.Connection;
const RedisManager_1 = require("./Persistence/RedisManager");
exports.RedisManager = RedisManager_1.RedisManager;
const Container_1 = require("./utils/Container");
exports.useContainer = Container_1.useContainer;
/**
 * Create redis connection
 *
 * @export
 * @param options
 * @returns
 */
function createRedisConnection(options) {
    return __awaiter(this, void 0, void 0, function* () {
        const conn = Container_1.getFromContainer(Connection_1.Connection);
        yield conn.connect(options);
        return conn;
    });
}
exports.createRedisConnection = createRedisConnection;
/**
 * Return redis manager
 *
 * @export
 * @returns
 */
function getRedisManager() {
    const conn = Container_1.getFromContainer(Connection_1.Connection);
    return conn.manager;
}
exports.getRedisManager = getRedisManager;
__export(require("./Metadata/Metadata"));
__export(require("./Errors/Errors"));
__export(require("./Decorators/Entity"));
__export(require("./Decorators/IdentifyProperty"));
__export(require("./Decorators/Property"));
__export(require("./Decorators/RelationProperty"));
//# sourceMappingURL=index.js.map