/**
 * Service container interface
 *
 * @export
 * @interface ContainerInterface
 */
export interface ContainerInterface {
    get<T>(cl: {
        new (...args: any[]): T;
    }): T;
}
/**
 * Set up service container to use
 *
 * @export
 * @param container
 */
export declare function useContainer(container: ContainerInterface): void;
/**
 * Return class instance from container
 *
 * @export
 * @template T
 * @param cl
 * @returns
 */
export declare function getFromContainer<T>(cl: {
    new (...args: any[]): T;
}): T;
