"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const defaultContainerInstances = new Map();
let usedContainer = {
    get: cl => {
        let ins = defaultContainerInstances.get(cl);
        if (!ins) {
            ins = new cl();
            defaultContainerInstances.set(cl, ins);
        }
        return ins;
    }
};
/**
 * Set up service container to use
 *
 * @export
 * @param container
 */
function useContainer(container) {
    usedContainer = container;
}
exports.useContainer = useContainer;
/**
 * Return class instance from container
 *
 * @export
 * @template T
 * @param cl
 * @returns
 */
function getFromContainer(cl) {
    return usedContainer.get(cl);
}
exports.getFromContainer = getFromContainer;
//# sourceMappingURL=Container.js.map