"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * Check if given function constructor has given prototype in inheritance chain
 *
 * @export
 * @template TProto
 * @param cl
 * @param checkProto
 * @returns
 */
function hasPrototypeOf(cl, checkProto) {
    if (!cl) {
        return false;
    }
    let prototype = cl.prototype;
    while (prototype) {
        if (prototype === checkProto.prototype) {
            return true;
        }
        prototype = Object.getPrototypeOf(prototype);
    }
    return false;
}
exports.hasPrototypeOf = hasPrototypeOf;
//# sourceMappingURL=hasPrototypeOf.js.map